#include "adlib.h"

void SndOutput(unsigned int regAddr, unsigned int dataByte)
{
  unsigned int i,tmp;

   outp(0x388, regAddr);
   tmp = inp(0x388);
   tmp = inp(0x388);
   tmp = inp(0x388);
   tmp = inp(0x388);
   tmp = inp(0x388);
   tmp = inp(0x388);

   outp(0x389, dataByte);
   for (i = 0; i<37; i++)
      tmp = inp(0x388);
}

int AdlibPresent(unsigned int genAddr)
{
   unsigned int t1, i, t2, tmp;

   SndOutput(4, 0x60);    //mask T1 & T2
   SndOutput(4, 0x80);    //reset IRQ

   t1 = inp(0x388);            //read status register
   SndOutput(2, 0xFF);    //set timer-1 latch
   SndOutput(4, 0x21);    //unmask & start T1

   for (i = 0; i<201; i++)            //100 uSec delay for timer-1 overflow
      tmp = inp(genAddr);

   t2 = inp(0x388);            //read status register
   SndOutput(4, 0x60);
   SndOutput(4, 0x80);

   if ((t1 & 0xE0) == 0 && (t2 & 0xE0) == 0xC0)
      return(1);  // no board present...what a shame... =(
   else
      return(0);  // we've got 1!!!
}
