// [ZEN] ----8< Clip here >8----
// [ZEN] Mods by : Stacy Doss Inet => sdoss@tamu.edu
// [ZEN] BC Option changes:
// [ZEN]    Personal Preferences :
// [ZEN]    Options => Environment => Editor => Persistant blocks (off)
// [ZEN]    Options => Environment => Editor => Overwrite blocks  (on)
// [ZEN]    Options => Environment => Editor => Tab Size (4)
// [ZEN]
// [ZEN] Modifications:
// [ZEN]   [06/26/94] Reformated source for readability
// [ZEN]   [06/26/94] Add some comment headers for readability
// [ZEN]   [06/26/94] Fixed BASM stuff in HscOps::play_song()
// [ZEN]   [06/26/94] Fixed extern declarations
// [ZEN]   [06/26/94] Add skeleatal main()
// [ZEN]   [06/26/94] Add a project notes "File" (actually contained in GHSC.PRJ)
// [ZEN]
// [ZEN] ----8< Clip here >8----
// [ZEN] ---- Paste to project notes ----

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>
#include <io.h>
#include <fcntl.h>
#include "hscops.h"

// [ZEN] This is required for externs, prevents "name mangleing"
extern "C" {
           void  far pascal _hscplayer();
           } // End of extern "C" {

// ************************
// *** Member Functions ***
// ************************
HscOps::HscOps(void)
{
     //song_addr = new char[63999];
     Msegment = 0;
     Moffset = 0;
}

// ************************


HscOps::~HscOps(void)
{
      delete song_addr;
}

// ************************

void HscOps::play_song(void)
{
    unsigned int Lsegment = Msegment;       // [ZEN] See Notes in Window => Project Notes
    unsigned int Loffset = Moffset;         // [ZEN] Remove or change these comments when
                                            // [ZEN]   Project Notes are read.
    asm {
        mov   ax, Lsegment
        mov   es, ax
        mov   ax, Loffset
        mov   si, ax

        xor	ax,ax                           // Set'em all to zero.
     	xor	bx,bx                           // I had probs if I didn't do it.
     	xor cx,cx
     	xor	dx,dx
     	mov	ah,0x0
     	mov	bh,0x0
     	mov	bl,0x0                          // Function 0 : Start Playing
     }
    _hscplayer();
}

// ************************


void HscOps::stop_song(void)
{
    asm {
 		xor	ax,ax
  		mov	ah,0x2                          // Function 2 : Stop playing
    }
    _hscplayer();
}

// ************************

int HscOps::load_song(char *song_name)
{
    int handle;                             // variable for file handle
    unsigned long s_size;                   // size of the song (in bytes)

    if( (handle = open(song_name, O_RDONLY | O_BINARY)) == -1)
    {
        close(handle);
        return(1);
    }

    s_size = filelength(handle);            // get the size of the file
    if ( s_size > farcoreleft() )
    {
        close(handle);
        return(2);
    }
    else
    {
        song_addr = new char [s_size];      // [ZEN] Very good :) I almost always forget to do this.
        read(handle, song_addr, s_size);
        close(handle);
    }
    Msegment = (unsigned int)FP_SEG(song_addr);
    Moffset = (unsigned int)FP_OFF(song_addr);

    return(0);
}

